#ifndef _OBJECTADAPTER_H
#define _OBJECTADAPTER_H

#include <tao/corba.h>
#include <tao/PortableServer/PortableServer.h>
#include <tao/PortableServer/POA.h>
#include "macro.h"

#ifndef OPENFUSION_COMMON_DLL
#define OPENFUSION_COMMON_DLL
#endif

class OPENFUSION_COMMON_DLL ObjectAdapter
{
   public:

   ObjectAdapter( CORBA::ORB_var& orb, const CORBA::Boolean bAgent = 0);

   ObjectAdapter( CORBA::ORB_var& orb, const char *sPoaName, const CORBA::Boolean bAgent = 0);

   ObjectAdapter( CORBA::ORB_var& orb, ObjectAdapter *adp, const char *sPoaName, const CORBA::Boolean bPersistent = 0, const CORBA::Boolean bAgent = 0);

   virtual ~ObjectAdapter()
   {
   };

   void create( CORBA::ORB_var& orb, CORBA::Boolean bPersistent = 0);
   void create( CORBA::ORB_var& orb, 
                PortableServer::ServantBase *impl, 
                CORBA::Boolean bPersistent = 0);

   void createPersistent( CORBA::ORB_var& orb);
   void createPersistent( CORBA::ORB_var& orb, PortableServer::ServantBase *impl);

   void createTransient( CORBA::ORB_var& orb);
   void createTransient( CORBA::ORB_var& orb, PortableServer::ServantBase *impl);

   PortableServer::POA_var getPOA();

   void addServantToAdapter( PortableServer::ServantBase *impl, 
                             const char *sName,
                             CORBA::Boolean bPersistent = 0);

   ObjectAdapter *getParent() const;

   void activateManager();

   char *getPoaName();

   protected:

   private:

      void initialiseRootPOA (CORBA::ORB_var &orb);

      PortableServer::POA_var m_thisPOA;

      PortableServer::POA_var m_rootPOA;

      PortableServer::POAManager_var m_poaManager;

      PortableServer::ObjectId_var m_managerId;

      CORBA::Boolean m_bAgent;

      ObjectAdapter *m_parentOA;

      char m_sPoaName[255];
};
#endif  // _OBJECTADAPTER_H
