#include <ace/streams.h>
#include "Basic.hh"
#include <Common/Accessor.hh>

int main (int argc, char **argv)
{
   try
   {
      Accessor utils;
   
      CORBA::ORB_var pOrb;
   
      try
      {
         pOrb = utils.getORB (argc, argv);
         cout << "INFO: initialised orb" << endl;
      }
      catch(CORBA::Exception& e)
      {
         cout << "ERROR: Cannot initialise orb" << endl;
         cerr << e << endl;
   
         return 1;
      }
   
      Basic* basic = new Basic (pOrb);
   
      DsLogAdmin::BasicLogFactory_var factory = basic->resolve (pOrb);
   
      DsLogAdmin::BasicLog_var log = basic->create (factory);
   
      basic->write (log);
   
      basic->query (log);
   
      log->destroy ();
   
      cout << "Destroyed log object" << endl;
   
      return 0;
   }
   catch(CORBA::Exception& sysEx)
   {
      cerr << sysEx << endl;
      return 1;
   }

}
