#ifndef _EVENT_H
#define _EVENT_H

#include <ace/streams.h>
#include <ace/OS.h>
#include <tao/corba.h>
#include "macro.h"

#include <DsLogAdminC.h>
#include <DsEventLogAdminC.h>

#include <CosEventCommC.h>
#include <CosEventCommS.h>
#include <CosEventChannelAdminC.h>
#include <CosEventChannelAdminS.h>

#ifndef OPENFUSION_EVENT_DLL
#define OPENFUSION_EVENT_DLL
#endif

class OPENFUSION_EVENT_DLL Event : public POA_CosEventComm::PushSupplier
{
   public:

   Event (CORBA::ORB_var orb);

   DsEventLogAdmin::EventLogFactory_var resolve (CORBA::ORB_var orb);

   DsEventLogAdmin::EventLog_var create (DsEventLogAdmin::EventLogFactory_var factory);

   void connect (DsEventLogAdmin::EventLog_var channel);

   void generate ();

   void disconnect ();

   virtual void disconnect_push_supplier () throw (CORBA::SystemException)
   {
      cout << "Disconnected by proxy" << endl;
   }

   CosEventComm::PushSupplier_var getCORBARef ()
   {
      return _this ();
   }


   protected:

   private:

      CORBA::ORB_var orb;
      DsEventLogAdmin::EventLogFactory_var event_log_factory;
      CosEventChannelAdmin::ProxyPushConsumer_var proxy;
};

#endif
