#ifndef _NOTIFY_H
#define _NOTIFY_H

#include <ace/streams.h>
#include <ace/OS.h>
#include <tao/corba.h>
#include "macro.h"

#include <DsLogAdminC.h>
#include <DsNotifyLogAdminC.h>

#include <CosNotificationC.h>
#include <CosNotifyCommC.h>
#include <CosNotifyCommS.h>
#include <CosNotifyChannelAdminC.h>
#include <CosNotifyFilterC.h>

#ifndef OPENFUSION_NOTIFY_DLL
#define OPENFUSION_NOTIFY_DLL
#endif

class OPENFUSION_NOTIFY_DLL Notify : public POA_CosNotifyComm::PushSupplier
{
   public:

   Notify (CORBA::ORB_var orb);

   DsNotifyLogAdmin::NotifyLogFactory_var resolve (CORBA::ORB_var orb);

   DsNotifyLogAdmin::NotifyLog_var create (DsNotifyLogAdmin::NotifyLogFactory_var factory);

   void connect (DsNotifyLogAdmin::NotifyLog_var channel);

   void setFilter (DsNotifyLogAdmin::NotifyLog_var channel);

   void generate ();

   void disconnect ();

   virtual void disconnect_push_supplier () throw (CORBA::SystemException)
   {
      cout << "Disconnected by proxy" << endl;
   }

   virtual void subscription_change
      (
         class CosNotification::EventTypeSeq const &,
         class CosNotification::EventTypeSeq const &
      )
   throw (CosNotifyComm::InvalidEventType,CORBA::SystemException)
   {
      cerr << "Didn't expect subscription change from log!"<< endl;
   }


   CosNotifyComm::PushSupplier_var getCORBARef ()
   {
      return _this ();
   }


   protected:

   private:

      CORBA::ORB_var orb;
      DsNotifyLogAdmin::NotifyLogFactory_var notify_log_factory;
      CosNotifyChannelAdmin::ProxyPushConsumer_var proxy;
      CosNotifyChannelAdmin::ProxyConsumer_var pc;

};

#endif
