#include "Account.hh"

AccountImpl::AccountImpl (const char* name, CORBA::Float balance)
{
   _name = ACE_OS::strdup (name);
   _balance = balance;
}

AccountImpl::~AccountImpl ()
{
}

char * AccountImpl::name () ACE_THROW_SPEC ((CORBA::SystemException))
{
   return ACE_OS::strdup (_name);
}

CORBA::Float AccountImpl::balance () ACE_THROW_SPEC ((CORBA::SystemException))
{
   return _balance;
}

void AccountImpl::deposit (CORBA::Float amount)
      ACE_THROW_SPEC ((CORBA::SystemException))
{
   _balance += amount;
}

void AccountImpl::withdraw (CORBA::Float amount)
      ACE_THROW_SPEC ((CORBA::SystemException, Bank::Account::InsufficientFunds))
{
   if(amount > _balance)
   {
      cerr << "ERROR: Amount requested:" << amount << " exceeds available"
           << " balance of " << _balance << endl;
      throw Bank::Account::InsufficientFunds ();
   }
   else
   {
      _balance -= amount;
   }
}
