#ifndef _ACCOUNT_H
#define _ACCOUNT_H

#include <ace/OS.h>

#include "BankS.h"
#include "BankC.h"

#include <tao/corba.h>

#include <iostream.h>

#include "macro.h"

#ifndef OPENFUSION_BANK_DLL
#define OPENFUSION_BANK_DLL
#endif

class OPENFUSION_BANK_DLL AccountImpl : public POA_Bank::Account
{
   public:

   AccountImpl (const char* name, CORBA::Float balance);

   ~AccountImpl ();

   virtual char * name () ACE_THROW_SPEC ((CORBA::SystemException));

   virtual CORBA::Float balance () ACE_THROW_SPEC ((CORBA::SystemException));

   virtual void deposit (CORBA::Float amount)
      ACE_THROW_SPEC ((CORBA::SystemException));

   virtual void withdraw (CORBA::Float amount)
      ACE_THROW_SPEC ((CORBA::SystemException, Bank::Account::InsufficientFunds));

   private:
   CORBA::ORB_ptr orb;
   char* _name;
   CORBA::Float _balance;
   ACE_DECLARE_NEW_CORBA_ENV;
};
#endif
