#ifndef _ACCOUNTMANAGER_H
#define _ACCOUNTMANAGER_H

#include <ace/OS.h>

#include "BankS.h"
#include "BankC.h"

#include "Account.hh"
#include "Util.hh"

#include <tao/corba.h>
#include <tao/PortableServer/PortableServer.h>
#include <tao/PortableServer/POA.h>

#include <iostream.h>

#include "macro.h"

#ifndef OPENFUSION_BANK_DLL
#define OPENFUSION_BANK_DLL
#endif

class OPENFUSION_BANK_DLL AccountManagerImpl : public POA_Bank::AccountManager
{
   public:

   AccountManagerImpl (CORBA::ORB_ptr orb);

   ~AccountManagerImpl ()
   {
   }

   virtual void createAccount (const char * name, CORBA::Float amount)
      ACE_THROW_SPEC ((CORBA::SystemException));

   virtual Bank::Account_ptr getAccount (const char * name)
      ACE_THROW_SPEC ((CORBA::SystemException, Bank::AccountManager::NotFound));

   private:
   ACE_DECLARE_NEW_CORBA_ENV;
   Util* util;
   CORBA::ORB_ptr _orb;
   Bank::Account_ptr account;
};
#endif
