#ifndef _UTIL_H
#define _UTIL_H

#include <ace/OS.h>
#include <math.h>

#include <tao/corba.h>
#include <tao/PortableServer/PortableServer.h>
#include <tao/PortableServer/POA.h>
#include <stdlib.h>

#include "CosNamingC.h"
#include "CosNamingS.h"

#include "BankS.h"
#include "BankC.h"

#include "macro.h"

#ifndef OPENFUSION_BANK_DLL
#define OPENFUSION_BANK_DLL
#endif

class OPENFUSION_BANK_DLL Util
{
   private:

      CORBA::ORB_ptr _orb;

   public:

   Util (CORBA::ORB_ptr orb);

   void buildNameGraph ();

   CosNaming::NamingContextExt_var getRootNamingCtx (void);

   Bank::AccountManager_var getAccManagerObject (void);

   CosNaming::NamingContext_var getAccManagerCtx (void);

   CosNaming::NamingContext_var getAccountsCtx (void);

   void bindAccountManager (CORBA::Object_ptr obj);

   PortableServer::POA_var getPersistentRootPOA (void);

   Bank::Account_ptr getAccount (const char* name);

   void addAccount (const char* name, CORBA::Object_ptr obj);
};
#endif
