#include <ace/OS.h>
#include <tao/corba.h>
#include <iostream.h>

#include <CosNamingC.h>
#include <CosNamingS.h>

#include "Naming.hh"

/*
 * @func Constructs a Naming object
 */
Naming::Naming() {}

/*
 * @func Destroy a Naming object
 *
 */
Naming::~Naming() {}



CORBA::Boolean Naming::resolveToObject (CosNaming::Name *name, CosNaming::NamingContext_ptr cntx, CORBA::Object_ptr *obj)
{
   CORBA::Object_ptr object;
   try
   {
      object = cntx->resolve (*name);
   }
   catch(const CORBA::Exception& e)
   {
      cerr << "ERROR: cannot resolve name: " << e <<endl;
      return 0;
   }
   catch (...)
   {
      cout << "ERROR: problem resolving name" << endl;
      return 0;
   }

   if ( CORBA::is_nil (object))
   {
      cout << "ERROR: NULL object reference" << endl;
      return 0;
   }

   *obj = object;

   return 1;
}
