#include <ace/OS.h>
#include <tao/corba.h>
#include <tao/PortableServer/PortableServer.h>
#include <iostream.h>

#include "Common/ObjectAdapter.hh"
#include "VideoCompany.hh"
#include "VideoServiceProvider.hh"
#include "VideoSupplier.hh"
#include "NamingVideoSupplier.hh"

NamingVideoSupplier::NamingVideoSupplier (const char *sName , 
                                          CORBA::Boolean bStore)
   : VideoSupplier (sName, bStore)
{

   VideoSupplier::m_pServiceProvider->store (this);
   VideoSupplier::m_pServiceProvider->getObjectAdapter()->addServantToAdapter (this, sName, bStore);
}


NamingVideoSupplier::~NamingVideoSupplier() {}


CORBA::Boolean NamingVideoSupplier::bind (const CosNaming::NamingContext_ptr pInc)
{
// declare an arbitary name variable
   CosNaming::Name name;
   StringArray *array;

   name.length (1);

   try
   {
      CosNaming::NamingContext_var type = pInc->new_context();
      name[0].id = ACE_OS::strdup (getType());
      pInc->bind_new_context (name);
   }
// OK continue
   catch (...){}

// create contexts - ignoring those already existing

   for (ASA_Iter itb = ASA_Iter (m_videos); itb.next (array) != 0;
        itb.advance ())
   {
      name.length (2);
      try
      {
         CosNaming::NamingContext_var type = pInc->new_context();
         name[1].id = ACE_OS::strdup ((*array)[0]);
         pInc->bind_new_context (name);
      }
//    OK continue
      catch (...){}
      //
   }//end for

// bind this company into context
   name.length (3);

   for (ASA_Iter itb2 = ASA_Iter (m_videos); itb2.next (array) != 0;
        itb2.advance ())
   {
      name[1].id = ACE_OS::strdup ((*array)[0]);
      name[2].id = ACE_OS::strdup (getName());
      cout << getType() << ": " << (*array)[0] << ": " << getName() << endl;
      try
      {
         pInc->bind (name, getServant().in ());
      }
//       catch already bound and rebind on server re-start
      catch(CosNaming::NamingContext::AlreadyBound&)
      {
         try
         {
            cout << "WARNING: rebinding VideoCompany" << endl;
            pInc->rebind (name, getServant().in ());
         }
         catch (...)
         {
            cout << "ERROR: rebinding" << endl;
            return 0;
         }
      }
      catch (...)
      {
         cout << "ERROR: binding" << endl;
         return 0;
      }
   }//end for

   return 1;
}

/*
 * @func returns the CORBA reference of this object
 *
 * @rdesc the servant object reference
 */
CORBA::Object_var NamingVideoSupplier::getServant()
{
   return VideoSupplier::m_pServiceProvider->getObjectAdapter()->getPOA()->servant_to_reference (this);
}
