#include <ace/OS.h>
#include <iostream.h>

#include "VideoCompany.hh"
#include "VideoServiceProvider.hh"
#include "Common/ObjectAdapter.hh"


VideoServiceProvider::VideoServiceProvider (CORBA::ORB_var orb)
{
   m_adapter = new ObjectAdapter (orb);
   m_adapter->createPersistent (orb, this);
}


VideoServiceProvider::~VideoServiceProvider()
{

   delete m_adapter;
}


Server::CompanyNameList *VideoServiceProvider::getCompanies() throw (CORBA::SystemException)
{
   Server::CompanyNameList *companies = new Server::CompanyNameList;
   int iCount = 0;
   VideoCompany **company;

   cout << "\nService Provider: managed companies:" << endl;

   companies->length (m_companies.size());

   for (VideoCompanyArray::ITERATOR itb
           = VideoCompanyArray::ITERATOR (m_companies);
        itb.next (company) != 0; itb.advance ())
   {
      (*companies)[iCount] = ACE_OS::strdup ((*company)->getName());
      cout << (*company)->getName() << endl;
      iCount++;
   }

   return companies;
}


void VideoServiceProvider::store (VideoCompany *pCompany)
{
   m_companies.size (m_companies.size () + 1);
   m_companies[m_companies.size () - 1] = pCompany;
}

CORBA::Object_var VideoServiceProvider::getServant()
{
   return m_adapter->getPOA()->servant_to_reference (this);
}

//IDL client connection test
void VideoServiceProvider::helloWorld() throw (CORBA::SystemException)
{
   cout << "hello World" << endl;
}

#if defined (ACE_HAS_EXPLICIT_TEMPLATE_INSTANTIATION)
template class ACE_Array<VideoCompany*>;
template class ACE_Array_Base<VideoCompany*>;
template class ACE_Array_Iterator<VideoCompany*>;
#endif /* ACE_HAS_EXPLICIT_TEMPLATE_INSTANTIATION */
