#ifndef _VIDEOSERVICEPROVIDER_H
#define _VIDEOSERVICEPROVIDER_H

#include "Common/ServerS.h"
#include "Common/ServerC.h"
#include "Common/ObjectAdapter.hh"
#include <ace/Containers_T.h>
#include "macro.h"

typedef ACE_Array<VideoCompany*> VideoCompanyArray;

#ifndef OPENFUSION_VIDEO_DLL
#define OPENFUSION_VIDEO_DLL
#endif

class ObjectAdapter;

class OPENFUSION_VIDEO_DLL VideoServiceProvider:
   public POA_Server::ServiceProvider
{
   public:

      VideoServiceProvider(){}

      VideoServiceProvider (CORBA::ORB_var orb);

      ~VideoServiceProvider();

      Server::CompanyNameList* getCompanies() throw (CORBA::SystemException);

      void store (VideoCompany *pCompany);

      VideoCompanyArray m_companies;

      ObjectAdapter *getObjectAdapter() { return m_adapter;}

      CORBA::Object_var getServant();

      void helloWorld() throw (CORBA::SystemException);

   protected:

   private:
      ObjectAdapter *m_adapter;
};

#endif  // _VIDEOSERVICEPROVIDER_H
