#ifndef _VIDEOSUPPLIER_H
#define _VIDEOSUPPLIER_H

#include <ace/Containers_T.h>

typedef ACE_Array<char*> StringArray;
typedef ACE_Array<StringArray> Array_StringArray;
typedef Array_StringArray::ITERATOR ASA_Iter;

#include "macro.h"

#ifndef OPENFUSION_VIDEO_DLL
#define OPENFUSION_VIDEO_DLL
#endif

class VideoServiceProvider;

class OPENFUSION_VIDEO_DLL VideoSupplier : public VideoCompany
{
   public:

      static VideoServiceProvider *m_pServiceProvider;

      VideoSupplier (const char *sName, CORBA::Boolean bStore = 1);

      ~VideoSupplier();

      Server::OfferList* getOffers (const char *sCategory)
         throw (CORBA::SystemException);

      void addCategory (const char *sCategory);

      virtual CORBA::Object_var getServant();

      void addVideo (const char *sCategory, const char *sName);

      Array_StringArray m_videos;

   protected:

   private:
};
#endif  // _VIDEOSUPPLIER_H
