#ifndef _CHANNELMANAGER_H
#define _CHANNELMANAGER_H

#include "macro.h"

#ifndef OPENFUSION_MAIL_DLL
#define OPENFUSION_MAIL_DLL
#endif

#define  USERNAMELENGTH 8

#define  CONSTRAINT "NAME"


class OPENFUSION_MAIL_DLL ChannelManager
{

   public:

      ChannelManager();

      ChannelManager( CORBA::Object_var obj, int iChannelId= 0, CORBA::Boolean bCreate= 1);

      ~ChannelManager();

      CORBA::Boolean     setUserName( char *sName);

      char     *getUserName() const;

      void     setUser( char *sName, CORBA::Object_var obj);

      CORBA::Boolean     getStructuredProxyPullSupplier();

      CORBA::Boolean     getStructuredProxyPushConsumer();

      void     setStructuredProxyPushConsumer( CORBA::Object_var obj);

      CORBA::Boolean     getStructuredProxyPullSupplierIOR( CORBA::ORB_var pOrb, char **sResult) const;

      CORBA::Boolean     applyFilterToProxyPullSupplier( const char *sName, const char *sValue) const;

      CORBA::Boolean     applyFilterToProxyPullSupplier() const;

      CORBA::Boolean     pushEvent( char *sName, char *sMessage) const;

      CORBA::Boolean     receiveEvent() const;

      CORBA::Boolean     connectSupplier( PushSupplier *pSupplier) const;

      CORBA::Boolean     connectConsumer( PullConsumer *pConsumer) const;

      CORBA::Boolean     disconnectConsumer() const;

      CORBA::Boolean     disconnectSupplier() const;

   protected:

   private:

      CosNotifyChannelAdmin::EventChannel_var m_channel;

      CosNotifyChannelAdmin::StructuredProxyPullSupplier_var m_proxyPullSupplier;

      CosNotifyChannelAdmin::StructuredProxyPushConsumer_var m_proxyPushConsumer;

      char m_cUserName[USERNAMELENGTH];
};
#endif  // _CHANNELMANAGER_H
