#ifndef _INPUTMANAGER_H
#define _INPUTMANAGER_H

#include <ace/Containers_T.h>
#include "macro.h"

#ifndef OPENFUSION_MAIL_DLL
#define OPENFUSION_MAIL_DLL
#endif

typedef ACE_Array<void*> VoidArray;
typedef ACE_Array<VoidArray> Array_VoidArray;


class OPENFUSION_MAIL_DLL InputManager
{

   public:

      InputManager( CREATE sCreate, SEND sSend, RECEIVE sReceive, LOGIN sLogin, LOGOUT sLogout);

      ~InputManager();

      CORBA::Boolean getCommand();

      CORBA::Boolean despatch() const;

      void setPrompt( const char *sPrompt);

      void setDefaultPrompt();

      char *getDefaultPrompt();

      CORBA::Boolean isLoggedOn();

      char *getPrompt();

   protected:

   private:

      Array_VoidArray  m_command;

      char m_cPrompt[40];

      char m_sErrorString[1024];

      char m_sAdmin[16];
};
#endif  // _INPUTMANAGER_H
