#ifndef _CHANNELMANAGER_H
#define _CHANNELMANAGER_H

#include "macro.h"

#ifndef OPENFUSION_NEWS_DLL
#define OPENFUSION_NEWS_DLL
#endif


#define  USERNAMELENGTH 8

class OPENFUSION_NEWS_DLL ChannelManager
{

   public:

      ChannelManager();

      ChannelManager( CORBA::Object_ptr obj, int iChannelId= 0, CORBA::Boolean bCreate= 1);

      ~ChannelManager();

      CORBA::Boolean getStructuredProxyPushSupplier();

      CORBA::Boolean getStructuredProxyPushConsumer();

     void setStructuredProxyPushSupplier( CORBA::Object_ptr pProxy);

      CORBA::Boolean getStructuredProxyPushSupplierFromId();

      CosNotifyChannelAdmin::StructuredProxyPushSupplier_var returnStructuredProxyPushSupplier();

      CORBA::Boolean connectSupplier( CosNotifyComm::StructuredPushSupplier_ptr pSupplier, const CORBA::Boolean bPublisher=0);

      CORBA::Boolean connectConsumer( CosNotifyComm::StructuredPushConsumer_ptr pConsumer, int& iOpt);

      CORBA::Boolean disconnectConsumer() const;

      CORBA::Boolean getPublisher();

      CORBA::Boolean getSubscriber();

      CORBA::Boolean suspend() const;

      CORBA::Boolean resume() const;

   protected:

      void setPersistentQos() const;

      CosNotifyChannelAdmin::EventChannel_var m_channel;

      CosNotifyChannelAdmin::StructuredProxyPushConsumer_var m_proxyPushConsumer;

      CosNotifyChannelAdmin::StructuredProxyPushSupplier_var m_proxyPushSupplier;

      CosNotifyComm::NotifyPublish_var m_publisher;

      CosNotifyComm::NotifySubscribe_var m_subscriber;

   private:
};
#endif  // _CHANNELMANAGER_H
