#include <ace/OS.h>
#include <tao/corba.h>

#include <iostream.h>
#include <string.h>

#include "InputManager.hh"
/*
 * @func Constructs a CInputManager object
 *
 * @parm | sHelp | the given help prompt
 */
InputManager::InputManager( const char* sHelp)
{
// set the default prompt
   setDefaultPrompt();
// prepare the help prompt
   ACE_OS::strcpy( m_sErrorString, sHelp);
   ACE_OS::strcpy( m_sAdmin, "ADMIN>");
}

/*
 * @func destroy this object
 *
 */
InputManager::~InputManager(){}

/*
 * @func set the defualt prompt
 *
 */
void InputManager::setDefaultPrompt()
{
   ACE_OS::strcpy( m_cPrompt, getDefaultPrompt());
}

/*
 * @func get the defualt prompt
 *
 * @rdesc the defualt prompt
 */
char *InputManager::getDefaultPrompt() const
{
   return (char *)m_sAdmin;
}

/*
 * @func get the current prompt
 *
 * @rdesc the current prompt
 */
char *InputManager::getPrompt()
{
   return m_cPrompt;
}

/*
 * @func get the command input
 *
 * @rdesc true if success
 */
CORBA::Boolean InputManager::getCommand()
{
   char cCommand[40];
   cout << m_cPrompt;
   cin.getline( cCommand, 40);
#if defined DIGITAL_UNIX
   #if DIGITAL_UNIX < 0x500
   cin.ignore ();
   #endif
#endif

   return 1;
}

/*
 * @func sets the command prompt
 *
 * @parm | sPrompt| the command prompt
 */
void InputManager::setPrompt( const char *sPrompt)
{
   ACE_OS::strcpy( m_cPrompt, sPrompt);
}

/*
 * @func returns the help string
 *
 */
char *InputManager::getHelpPrompt()
{
   return m_sErrorString;
}

#if defined (ACE_HAS_EXPLICIT_TEMPLATE_INSTANTIATION)
template class ACE_Array<void*>;
template class ACE_Array_Base<void*>;
template class ACE_Array_Iterator<void*>;
template class ACE_Array<VoidArray>;
template class ACE_Array_Base<VoidArray>;
template class ACE_Array_Iterator<VoidArray>;
#endif /* ACE_HAS_EXPLICIT_TEMPLATE_INSTANTIATION */
