#ifndef _INPUTMANAGER_H
#define _INPUTMANAGER_H

#include <ace/Containers_T.h>
#include "macro.h"

#ifndef OPENFUSION_NEWS_DLL
#define OPENFUSION_NEWS_DLL
#endif

typedef ACE_Array<void*> VoidArray;
typedef ACE_Array<VoidArray> Array_VoidArray;

class OPENFUSION_NEWS_DLL InputManager
{

   public:

      InputManager( const char* sHelp);

      ~InputManager();

      CORBA::Boolean getCommand();

      virtual CORBA::Boolean despatch()= 0;

      void setPrompt( const char *sPrompt);

      void setDefaultPrompt();

      char *getDefaultPrompt() const;

      char *getPrompt();

      char *getHelpPrompt();

   protected:

      Array_VoidArray  m_command;

   private:

      char m_cPrompt[255];

      char m_sErrorString[1024];

      char m_sAdmin[16];
};
#endif  // _INPUTMANAGER_H
