#ifndef _PUSHCONSUMER_H
#define _PUSHCONSUMER_H

#include <tao/corba.h>
#include "macro.h"

#ifndef OPENFUSION_NEWS_DLL
#define OPENFUSION_NEWS_DLL
#endif

typedef void (*STOP)();
typedef void (*START)();


class OPENFUSION_NEWS_DLL PushConsumer : public POA_CosNotifyComm::StructuredPushConsumer
{

   public:

      PushConsumer( STOP sStop, START sStart);

      ~PushConsumer();

      virtual void disconnect_structured_push_consumer() throw (CORBA::SystemException);

      virtual void offer_change( const CosNotification::EventTypeSeq& added, const CosNotification::EventTypeSeq& removed) throw (CosNotifyComm::InvalidEventType,CORBA::SystemException);

      virtual void push_structured_event(const CosNotification::StructuredEvent& _notification) throw (CosEventComm::Disconnected,CORBA::SystemException);

      void setSubscribedEvent( const int iType);

      CORBA::Boolean getSubscribedType( const int iType);

   protected:

   private:

      STOP m_stopFunc;

      START m_startFunc;

      CORBA::Boolean m_bWeather;

      CORBA::Boolean m_bStocks;

};
#endif  // _PUSHCONSUMER_H
