#include "Mortgage.hh"

MortgageImpl::MortgageImpl (const char* name, CORBA::Float rate)
{
   _name = ACE_OS::strdup (name);
   _rate = rate/100;
}

MortgageImpl::~MortgageImpl ()
{
}

char * MortgageImpl::name () ACE_THROW_SPEC ((CORBA::SystemException))
{
   return ACE_OS::strdup (_name);
}

CORBA::Float MortgageImpl::rate () ACE_THROW_SPEC ((CORBA::SystemException))
{
   return _rate;
}


void MortgageImpl::calculateMortgage (CORBA::Long loan_amount, CORBA::Short years)
      ACE_THROW_SPEC ((CORBA::SystemException))
{
   CORBA::Double annual_payments = 0.0;
   CORBA::Double monthly_payments = 0.0;

   annual_payments = ((loan_amount*pow ((1+_rate),years)*_rate))/((pow ((1+_rate),years)-1));
   monthly_payments = annual_payments/12;

   cout << "Your annual payments for a $" << loan_amount << " mortgage over "
        << years << " years with " << name () << " will be: $" << annual_payments << endl;

   cout << "Your monthly payments for a $" << loan_amount << " mortgage over "
        << years << " years with " << name () << " will be: $" << monthly_payments << endl;
}
