#ifndef _MORTGAGE_H
#define _MORTGAGE_H

#include <ace/OS.h>

#include "MortgageS.h"
#include "MortgageC.h"

#include <tao/corba.h>

#include <iostream.h>
#include <math.h>

#include "macro.h"

#ifndef OPENFUSION_MORTGAGE_DLL
#define OPENFUSION_MORTGAGE_DLL
#endif

class OPENFUSION_MORTGAGE_DLL MortgageImpl : public POA_Mortgage
{
   public:

   MortgageImpl (const char* name, CORBA::Float rate);

   ~MortgageImpl ();

   virtual char * name () ACE_THROW_SPEC ((CORBA::SystemException));

   virtual CORBA::Float rate () ACE_THROW_SPEC ((CORBA::SystemException));

   virtual void calculateMortgage (CORBA::Long loan_amount, CORBA::Short years)
      ACE_THROW_SPEC ((CORBA::SystemException));

   private:
   char* _name;
   CORBA::Float _rate;
   ACE_DECLARE_NEW_CORBA_ENV;
};
#endif
