#include "Util.hh"

Util::Util (CORBA::ORB_ptr orb)
{
   _orb = orb;
}

PortableServer::POA_var Util::getPersistentRootPOA (void)
{
   try
   {
      CORBA::Object_var obj = _orb->resolve_initial_references ("RootPOA");

      PortableServer::POA_var rootPOA = PortableServer::POA::_narrow (obj.in ());

      return rootPOA;
   }
   catch(const CORBA::Exception& ex)
   {
      ex._tao_print_exception ("getPersistentRootPOA:Unexpected exception during RIR for RootPOA...");
      exit (-1);
   }
}
