#ifndef _VIDEOSERVICEPROVIDER_H
#define _VIDEOSERVICEPROVIDER_H

#include "Common/ServerS.h"
#include "Common/ServerC.h"
#include "Common/ObjectAdapter.hh"

#include <ace/Containers_T.h>
#include "macro.h"

typedef ACE_Array<VideoCompany*> VideoCompanyArray;

#ifndef OPENFUSION_VIDEO_DLL
#define OPENFUSION_VIDEO_DLL
#endif

class ObjectAdapter;


class OPENFUSION_VIDEO_DLL VideoServiceProvider : public POA_Server::ServiceProvider
{

   public:

      VideoServiceProvider(){}

      VideoServiceProvider( CORBA::ORB_var orb);

      ~VideoServiceProvider();

      Server::CompanyNameList* getCompanies() throw (CORBA::SystemException);

      void store( CORBA::ORB_var orb, VideoCompany *pCompany, char *sName);

      VideoCompanyArray m_companies;

      ObjectAdapter *getObjectAdapter() { return m_adapter;}

      ObjectAdapter *getVideoObjectAdapter() { return m_adapterVideos;}

      CORBA::Object_var getServant();

      void activateManager();

      void helloWorld() throw (CORBA::SystemException);

   protected:

   private:
      ObjectAdapter *m_adapter;
      ObjectAdapter *m_adapterVideos;
};

#endif  // _VIDEOSERVICEPROVIDER_H
