// -*- C++ -*-

//=============================================================================
/**
 *  @file    TAO_UTF16.h
 *
 *  TAO_UTF16.h,v 1.3 2003/12/08 02:42:50 bala Exp
 */
//=============================================================================

#ifndef TAO_UTF16_H
#define TAO_UTF16_H
#include /**/ "ace/pre.h"

//#include "ace/config-all.h"

#include "ace/CDR_Stream.h"
#include "TAO_Export.h"


// ****************************************************************

/**
 * @class TAO_UTF16
 * @brief Codeset translation specialization.
 *
 * @author Simon McQueen <sm@prismtechnologies.com>
 */
class TAO_Export TAO_UTF16 : public ACE_WChar_Codeset_Translator
{
public:
  /// A do nothing constructor.
  TAO_UTF16 (void);

  /// Virtual destruction
  virtual ~TAO_UTF16 (void);

  // = Documented in $ACE_ROOT/ace/CDR_Stream.h
  virtual ACE_CDR::Boolean read_wchar (ACE_InputCDR &,
                                      ACE_CDR::WChar &);
  virtual ACE_CDR::Boolean read_wstring (ACE_InputCDR &,
                                        ACE_CDR::WChar *&);
  virtual ACE_CDR::Boolean read_wchar_array (ACE_InputCDR&,
                                             ACE_CDR::WChar*,
                                             ACE_CDR::ULong);                                          
  virtual ACE_CDR::Boolean write_wchar (ACE_OutputCDR &,
                                       ACE_CDR::WChar);
  virtual ACE_CDR::Boolean write_wstring (ACE_OutputCDR &,
                                         ACE_CDR::ULong,
                                         const ACE_CDR::WChar *);
  virtual ACE_CDR::Boolean write_wchar_array (ACE_OutputCDR&,
                                              const ACE_CDR::WChar*,
                                              ACE_CDR::ULong);
  virtual ACE_CDR::ULong ncs () {return 0x00010104;}
  virtual ACE_CDR::ULong tcs () {return 0x00010109;}

private:
  ACE_CDR::Octet tcs_size_;
};

#include /**/ "ace/post.h"
#endif /* TAO_UTF16_H */
