#!/bin/sh

TestOS=`uname -a | cut -d" " -f3`

if [ -z "$1" ]
then
   echo "Usage: $0 <install_directory>"
   exit
fi

if [ ! -f "tao.tar.gz" ]
then
   echo "Unable to find tao.tar.gz. Aborting."
   exit
fi

if [ -z "`echo $1 | grep '^/.*'`" ]
then
   echo "Install using explicit path not relative"
   exit
fi

echo "Unzipping tar"
gunzip tao.tar.gz

mkdir -p $1
TARFILE=`pwd`/tao.tar
cd $1

echo "Extracting tar"

tar xof $TARFILE
chmod 755 *
chmod 644 $1/index.html
chmod 755 $1/bin/*
chmod 755 $1/lib/*

cd $1/lib
for i in lib*.so.*
do
  if [ -f $i ]
  then
    ln -s $i `echo $i | sed s/.so.*/.so/`
  fi
done

for i in lib*.sl.*
do
  if [ -f $i ]
  then
    ln -s $i `echo $i | sed s/.sl.*/.sl/`
  fi
done

for i in lib*.a.*
do
  if [ -f $i ]
  then
    ln -s $i `echo $i | sed s/.a.*/.a/`
  fi
done

echo "Done"
